//+------------------------------------------------------------------+
//|                                                 JS_Urovni_V2.mq5 |
//|                                               Copyright VDV Soft |
//|                                                 vdv_2001@mail.ru |
//+------------------------------------------------------------------+
#property copyright "VDV Soft"
#property link      "vdv_2001@mail.ru"
#property version   "1.00"
#property description  "  MQL5   \n http://codebase.mql4.com/ru/6291\n   "
#property indicator_chart_window

#include <Arrays\List.mqh>
#include <ChartObjects\ChartObjectsLines.mqh>

input int   InpMonthlyCount=-1; // -  (-1 - )
input color InpColorHigh=RoyalBlue; //  
input color InpColorLow=Crimson; //  
input ENUM_LINE_STYLE InpStyle=STYLE_SOLID; //  
input int   InpWidth=1; //  
CList    ListObject;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   static int count_bars=0,total,count;
   if(count_bars!=Bars(NULL,PERIOD_MN1))
     {
      ListObject.Clear();
      MqlRates rates[];
      int err=0;
      do
        {
         //        / Account of quantity of days proceeding from an accessible history
         count_bars=Bars(NULL,PERIOD_MN1);
         if(InpMonthlyCount+1<count_bars)
            count=InpMonthlyCount+1;
         else
            count=count_bars;
         if(InpMonthlyCount<=0) count=count_bars;
         total=CopyRates(NULL,PERIOD_MN1,0,count,rates);
         err++;
        }
      while(total<=0 && err<10);
      if(err>=10)
        {
         Print("ERROR! There is no accessible history PERIOD_MN1");
         return(-1);
        }
      for(int i=total-2; i>=0; i--)
        {
         CChartObjectTrend *line=new CChartObjectTrend();
         line.Create(0,TimeToString(rates[i].time,TIME_DATE)+" High",0,rates[i].time,rates[i].high,time[rates_total-1],rates[i].high);
         line.Color(InpColorHigh);
         line.Width(InpWidth);
         line.Style(InpStyle);
         ListObject.Add(line);
         line=new CChartObjectTrend();
         line.Create(0,TimeToString(rates[i].time,TIME_DATE)+" Low",0,rates[i].time,rates[i].low,time[rates_total-1],rates[i].low);
         line.Color(InpColorLow);
         line.Width(InpWidth);
         line.Style(InpStyle);
         ListObject.Add(line);
        }
     }
//---
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
